package net.ibizsys.central.plugin.boot.core.runtime;

import com.fasterxml.jackson.core.JsonProcessingException;
import net.ibizsys.central.plugin.spring.service.client.WebFluxClient;
import net.ibizsys.runtime.util.IEntity;
import org.springframework.http.MediaType;
import org.springframework.util.ObjectUtils;
import org.springframework.util.StringUtils;

public class BootWebFluxClient extends WebFluxClient {

    @Override
    protected Object getBodyContent(Object objValue, String strContentType) throws JsonProcessingException {
        if(ObjectUtils.isEmpty(objValue)) {
            return objValue;
        }

        if(objValue instanceof IEntity){
            objValue = ((IEntity)objValue).any();
        }

        if(!StringUtils.hasLength(strContentType) || strContentType.equals(MediaType.APPLICATION_JSON_VALUE)) {
            return OUTMAPPER.writeValueAsString(objValue);
        }

        return objValue;
    }

}
